diff --git a/compiler/types/TypeRep.lhs b/compiler/types/TypeRep.lhs
index 62c5a11..78ccfc5 100644
--- a/compiler/types/TypeRep.lhs
+++ b/compiler/types/TypeRep.lhs
@@ -15,19 +15,13 @@ Note [The Type-related module hierarchy]
   Coercion imports Type
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 -- We expose the relevant stuff from this module via the Type module
 {-# OPTIONS_HADDOCK hide #-}
 {-# LANGUAGE DeriveDataTypeable, DeriveFunctor, DeriveFoldable, DeriveTraversable #-}
 module TypeRep (
-	TyThing(..),
-	Type(..),
+        TyThing(..),
+        Type(..),
         TyLit(..),
         KindOrType, Kind, SuperKind,
         PredType, ThetaType,      -- Synonyms
@@ -37,11 +31,11 @@ module TypeRep (
         isLiftedTypeKind, isSuperKind, isTypeVar, isKindVar,
         
         -- Pretty-printing
-	pprType, pprParendType, pprTypeApp, pprTvBndr, pprTvBndrs,
-	pprTyThing, pprTyThingCategory, pprSigmaType,
-	pprEqPred, pprTheta, pprForAll, pprThetaArrowTy, pprClassPred,
+        pprType, pprParendType, pprTypeApp, pprTvBndr, pprTvBndrs,
+        pprTyThing, pprTyThingCategory, pprSigmaType,
+        pprEqPred, pprTheta, pprForAll, pprThetaArrowTy, pprClassPred,
         pprKind, pprParendKind, pprTyLit, suppressKinds,
-	Prec(..), maybeParen, pprTcApp, 
+        Prec(..), maybeParen, pprTcApp, 
         pprPrefixApp, pprArrowChain, ppr_type,
 
         -- Free variables
@@ -91,9 +85,9 @@ import qualified Data.Data        as Data hiding ( TyCon )
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{The data type}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 
@@ -103,42 +97,42 @@ import qualified Data.Data        as Data hiding ( TyCon )
 -- If you edit this type, you may need to update the GHC formalism
 -- See Note [GHC Formalism] in coreSyn/CoreLint.lhs
 data Type
-  = TyVarTy Var	-- ^ Vanilla type or kind variable (*never* a coercion variable)
+  = TyVarTy Var -- ^ Vanilla type or kind variable (*never* a coercion variable)
 
   | AppTy         -- See Note [AppTy invariant]
-	Type
-	Type		-- ^ Type application to something other than a 'TyCon'. Parameters:
-	                --
+        Type
+        Type            -- ^ Type application to something other than a 'TyCon'. Parameters:
+                        --
                         --  1) Function: must /not/ be a 'TyConApp',
                         --     must be another 'AppTy', or 'TyVarTy'
-	                --
-	                --  2) Argument type
+                        --
+                        --  2) Argument type
 
   | TyConApp      -- See Note [AppTy invariant]
-	TyCon
-	[KindOrType]	-- ^ Application of a 'TyCon', including newtypes /and/ synonyms.
-	                -- Invariant: saturated appliations of 'FunTyCon' must
-	                -- use 'FunTy' and saturated synonyms must use their own
+        TyCon
+        [KindOrType]    -- ^ Application of a 'TyCon', including newtypes /and/ synonyms.
+                        -- Invariant: saturated appliations of 'FunTyCon' must
+                        -- use 'FunTy' and saturated synonyms must use their own
                         -- constructors. However, /unsaturated/ 'FunTyCon's
                         -- do appear as 'TyConApp's.
-	                -- Parameters:
-	                --
-	                -- 1) Type constructor being applied to.
-	                --
+                        -- Parameters:
+                        --
+                        -- 1) Type constructor being applied to.
+                        --
                         -- 2) Type arguments. Might not have enough type arguments
                         --    here to saturate the constructor.
                         --    Even type synonyms are not necessarily saturated;
                         --    for example unsaturated type synonyms
-	                --    can appear as the right hand side of a type synonym.
+                        --    can appear as the right hand side of a type synonym.
 
   | FunTy
-	Type		
-	Type		-- ^ Special case of 'TyConApp': @TyConApp FunTyCon [t1, t2]@
-			-- See Note [Equality-constrained types]
+        Type            
+        Type            -- ^ Special case of 'TyConApp': @TyConApp FunTyCon [t1, t2]@
+                        -- See Note [Equality-constrained types]
 
   | ForAllTy
-	Var         -- Type or kind variable
-	Type	        -- ^ A polymorphic type
+        Var         -- Type or kind variable
+        Type            -- ^ A polymorphic type
 
   | LitTy TyLit     -- ^ Type literals are similar to type constructors.
 
@@ -223,7 +217,7 @@ is encoded like this:
    blah
 
 -------------------------------------
- 		Note [PredTy]
+                Note [PredTy]
 
 \begin{code}
 -- | A type of the form @p@ of kind @Constraint@ represents a value whose type is
@@ -257,17 +251,17 @@ to expand to allow them.)
 
 A Haskell qualified type, such as that for f,g,h above, is
 represented using 
-	* a FunTy for the double arrow
-	* with a type of kind Constraint as the function argument
+        * a FunTy for the double arrow
+        * with a type of kind Constraint as the function argument
 
 The predicate really does turn into a real extra argument to the
 function.  If the argument has type (p :: Constraint) then the predicate p is
 represented by evidence of type p.
 
 %************************************************************************
-%*									*
+%*                                                                      *
             Simple constructors
-%*									*
+%*                                                                      *
 %************************************************************************
 
 These functions are here so that they can be used by TysPrim,
@@ -306,9 +300,9 @@ isKindVar v = isTKVar v && isSuperKind (varType v)
 
 
 %************************************************************************
-%*									*
-			Free variables of types and coercions
-%*									*
+%*                                                                      *
+                        Free variables of types and coercions
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -344,9 +338,9 @@ varSetElemsKvsFirst set
 \end{code}
 
 %************************************************************************
-%*									*
-			TyThing
-%*									*
+%*                                                                      *
+                        TyThing
+%*                                                                      *
 %************************************************************************
 
 Despite the fact that DataCon has to be imported via a hi-boot route, 
@@ -385,9 +379,9 @@ pprTyThingCategory (AnId   _)   = ptext (sLit "Identifier")
 pprTyThingCategory (ADataCon _) = ptext (sLit "Data constructor")
 
 
-instance NamedThing TyThing where	-- Can't put this with the type
-  getName (AnId id)     = getName id	-- decl, because the DataCon instance
-  getName (ATyCon tc)   = getName tc	-- isn't visible there
+instance NamedThing TyThing where       -- Can't put this with the type
+  getName (AnId id)     = getName id    -- decl, because the DataCon instance
+  getName (ATyCon tc)   = getName tc    -- isn't visible there
   getName (ACoAxiom cc) = getName cc
   getName (ADataCon dc) = dataConName dc
 
@@ -395,10 +389,10 @@ instance NamedThing TyThing where	-- Can't put this with the type
 
 
 %************************************************************************
-%*									*
-			Substitutions
+%*                                                                      *
+                        Substitutions
       Data type defined here to avoid unnecessary mutual recursion
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -415,37 +409,37 @@ instance NamedThing TyThing where	-- Can't put this with the type
 --
 -- 3. The substition is only applied ONCE! This is because
 -- in general such application will not reached a fixed point.
-data TvSubst 		
-  = TvSubst InScopeSet 	-- The in-scope type and kind variables
-	    TvSubstEnv  -- Substitutes both type and kind variables
-	-- See Note [Apply Once]
-	-- and Note [Extending the TvSubstEnv]
+data TvSubst            
+  = TvSubst InScopeSet  -- The in-scope type and kind variables
+            TvSubstEnv  -- Substitutes both type and kind variables
+        -- See Note [Apply Once]
+        -- and Note [Extending the TvSubstEnv]
 
 -- | A substitition of 'Type's for 'TyVar's
 --                 and 'Kind's for 'KindVar's
 type TvSubstEnv = TyVarEnv Type
-	-- A TvSubstEnv is used both inside a TvSubst (with the apply-once
-	-- invariant discussed in Note [Apply Once]), and also independently
-	-- in the middle of matching, and unification (see Types.Unify)
-	-- So you have to look at the context to know if it's idempotent or
-	-- apply-once or whatever
+        -- A TvSubstEnv is used both inside a TvSubst (with the apply-once
+        -- invariant discussed in Note [Apply Once]), and also independently
+        -- in the middle of matching, and unification (see Types.Unify)
+        -- So you have to look at the context to know if it's idempotent or
+        -- apply-once or whatever
 \end{code}
 
 Note [Apply Once]
 ~~~~~~~~~~~~~~~~~
 We use TvSubsts to instantiate things, and we might instantiate
-	forall a b. ty
+        forall a b. ty
 \with the types
-	[a, b], or [b, a].
+        [a, b], or [b, a].
 So the substition might go [a->b, b->a].  A similar situation arises in Core
 when we find a beta redex like
-	(/\ a /\ b -> e) b a
+        (/\ a /\ b -> e) b a
 Then we also end up with a substition that permutes type variables. Other
 variations happen to; for example [a -> (a, b)].  
 
-	***************************************************
-	*** So a TvSubst must be applied precisely once ***
-	***************************************************
+        ***************************************************
+        *** So a TvSubst must be applied precisely once ***
+        ***************************************************
 
 A TvSubst is not idempotent, but, unlike the non-idempotent substitution
 we use during unifications, it must not be repeatedly applied.
@@ -459,15 +453,15 @@ if the TvSubstEnv is empty --- i.e. (isEmptyTvSubt subst) holds ---
 then (substTy subst ty) does nothing.
 
 For example, consider:
-	(/\a. /\b:(a~Int). ...b..) Int
+        (/\a. /\b:(a~Int). ...b..) Int
 We substitute Int for 'a'.  The Unique of 'b' does not change, but
 nevertheless we add 'b' to the TvSubstEnv, because b's kind does change
 
 This invariant has several crucial consequences:
 
 * In substTyVarBndr, we need extend the TvSubstEnv 
-	- if the unique has changed
-	- or if the kind has changed
+        - if the unique has changed
+        - or if the kind has changed
 
 * In substTyVar, we do not need to consult the in-scope set;
   the TvSubstEnv is enough
@@ -478,7 +472,7 @@ This invariant has several crucial consequences:
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
                    Pretty-printing types
 
        Defined very early because of debug printing in assertions
@@ -491,15 +485,15 @@ parens around the type, except for the atomic cases.  @pprParendType@
 works just by setting the initial context precedence very high.
 
 \begin{code}
-data Prec = TopPrec 	-- No parens
-	  | FunPrec 	-- Function args; no parens for tycon apps
-	  | TyConPrec 	-- Tycon args; no parens for atomic
-	  deriving( Eq, Ord )
+data Prec = TopPrec     -- No parens
+          | FunPrec     -- Function args; no parens for tycon apps
+          | TyConPrec   -- Tycon args; no parens for atomic
+          deriving( Eq, Ord )
 
 maybeParen :: Prec -> Prec -> SDoc -> SDoc
 maybeParen ctxt_prec inner_prec pretty
   | ctxt_prec < inner_prec = pretty
-  | otherwise		   = parens pretty
+  | otherwise              = parens pretty
 
 ------------------
 pprType, pprParendType :: Type -> SDoc
@@ -531,7 +525,7 @@ pprClassPred clas tys = pprTypeApp (classTyCon clas) tys
 
 ------------
 pprTheta :: ThetaType -> SDoc
--- pprTheta [pred] = pprPred pred	 -- I'm in two minds about this
+-- pprTheta [pred] = pprPred pred        -- I'm in two minds about this
 pprTheta theta  = parens (sep (punctuate comma (map (ppr_type TopPrec) theta)))
 
 pprThetaArrowTy :: ThetaType -> SDoc
@@ -570,10 +564,10 @@ instance Outputable TyLit where
    ppr = pprTyLit
 
 ------------------
-	-- OK, here's the main printer
+        -- OK, here's the main printer
 
 ppr_type :: Prec -> Type -> SDoc
-ppr_type _ (TyVarTy tv)	      = ppr_tvar tv
+ppr_type _ (TyVarTy tv)       = ppr_tvar tv
 
 ppr_type _ (TyConApp tc [LitTy (StrTyLit n),ty])
   | tc `hasKey` ipClassNameKey
@@ -585,7 +579,7 @@ ppr_type p (LitTy l)          = ppr_tylit p l
 ppr_type p ty@(ForAllTy {})   = ppr_forall_type p ty
 
 ppr_type p (AppTy t1 t2) = maybeParen p TyConPrec $
-			   pprType t1 <+> ppr_type TyConPrec t2
+                           pprType t1 <+> ppr_type TyConPrec t2
 
 ppr_type p fun_ty@(FunTy ty1 ty2)
   | isPredTy ty1
@@ -650,9 +644,9 @@ pprTvBndrs tvs = sep (map pprTvBndr tvs)
 pprTvBndr :: TyVar -> SDoc
 pprTvBndr tv 
   | isLiftedTypeKind kind = ppr_tvar tv
-  | otherwise	          = parens (ppr_tvar tv <+> dcolon <+> pprKind kind)
-	     where
-	       kind = tyVarKind tv
+  | otherwise             = parens (ppr_tvar tv <+> dcolon <+> pprKind kind)
+             where
+               kind = tyVarKind tv
 \end{code}
 
 Note [Infix type variables]
@@ -792,9 +786,9 @@ pprArrowChain p (arg:args) = maybeParen p FunPrec $
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{TidyType}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Tidying is here because it has a special case for FlatSkol
@@ -811,7 +805,7 @@ tidyTyVarBndr :: TidyEnv -> TyVar -> (TidyEnv, TyVar)
 tidyTyVarBndr tidy_env@(occ_env, subst) tyvar
   = case tidyOccName occ_env occ1 of
       (tidy', occ') -> ((tidy', subst'), tyvar')
-	where
+        where
           subst' = extendVarEnv subst tyvar tyvar'
           tyvar' = setTyVarKind (setTyVarName tyvar name') kind'
           name'  = tidyNameOcc name occ'
@@ -844,15 +838,15 @@ tidyOpenTyVar :: TidyEnv -> TyVar -> (TidyEnv, TyVar)
 -- also 'tidyTyVarBndr'
 tidyOpenTyVar env@(_, subst) tyvar
   = case lookupVarEnv subst tyvar of
-	Just tyvar' -> (env, tyvar')		-- Already substituted
-	Nothing	    -> tidyTyVarBndr env tyvar	-- Treat it as a binder
+        Just tyvar' -> (env, tyvar')            -- Already substituted
+        Nothing     -> tidyTyVarBndr env tyvar  -- Treat it as a binder
 
 ---------------
 tidyTyVarOcc :: TidyEnv -> TyVar -> TyVar
 tidyTyVarOcc (_, subst) tv
   = case lookupVarEnv subst tv of
-	Nothing  -> tv
-	Just tv' -> tv'
+        Nothing  -> tv
+        Just tv' -> tv'
 
 ---------------
 tidyTypes :: TidyEnv -> [Type] -> [Type]
@@ -861,14 +855,14 @@ tidyTypes env tys = map (tidyType env) tys
 ---------------
 tidyType :: TidyEnv -> Type -> Type
 tidyType _   (LitTy n)            = LitTy n
-tidyType env (TyVarTy tv)	  = TyVarTy (tidyTyVarOcc env tv)
+tidyType env (TyVarTy tv)         = TyVarTy (tidyTyVarOcc env tv)
 tidyType env (TyConApp tycon tys) = let args = tidyTypes env tys
- 		                    in args `seqList` TyConApp tycon args
-tidyType env (AppTy fun arg)	  = (AppTy $! (tidyType env fun)) $! (tidyType env arg)
-tidyType env (FunTy fun arg)	  = (FunTy $! (tidyType env fun)) $! (tidyType env arg)
-tidyType env (ForAllTy tv ty)	  = ForAllTy tvp $! (tidyType envp ty)
-			          where
-			            (envp, tvp) = tidyTyVarBndr env tv
+                                    in args `seqList` TyConApp tycon args
+tidyType env (AppTy fun arg)      = (AppTy $! (tidyType env fun)) $! (tidyType env arg)
+tidyType env (FunTy fun arg)      = (FunTy $! (tidyType env fun)) $! (tidyType env arg)
+tidyType env (ForAllTy tv ty)     = ForAllTy tvp $! (tidyType envp ty)
+                                  where
+                                    (envp, tvp) = tidyTyVarBndr env tv
 
 ---------------
 -- | Grabs the free type variables, tidies them
